package com.b3dgs.tyrian;

import com.b3dgs.lionengine.game.shmup.AbstractBullet;
import com.b3dgs.lionengine.game.shmup.AbstractBulletFactory;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.tyrian.gameplay.ListBullet;
import com.b3dgs.tyrian.gameplay.bullet.CurvedBullet;
import com.b3dgs.tyrian.gameplay.bullet.HeavyMissileBullet;
import com.b3dgs.tyrian.gameplay.bullet.LinearBullet;
import com.b3dgs.tyrian.gameplay.bullet.MissileBullet;

public class BulletFactory extends AbstractBulletFactory<ListBullet> {

    private final RessourcesHandler rh;
    private final EffectHandler effects;

    public BulletFactory(RessourcesHandler rh, EffectHandler effects) {
        this.rh = rh;
        this.effects = effects;
    }

    @Override
    public AbstractBullet createBullet(ListBullet bullet, int id, int frame) {
        switch (bullet) {
            case Linear:
                return new LinearBullet(this.rh, id, frame, this.effects);
            case Curved:
                return new CurvedBullet(this.rh, id, frame, this.effects);
            case Missile:
                return new MissileBullet(this.rh, id, frame, this.effects);
            case HeavyMissile:
                return new HeavyMissileBullet(this.rh, id, frame, this.effects);
            default:
                return null;
        }
    }
}
