package com.b3dgs.tyrian;

import com.b3dgs.lionengine.Drawable;
import com.b3dgs.lionengine.drawable.Sprite;
import com.b3dgs.lionengine.engine.Loader;
import com.b3dgs.lionengine.engine.Sequence;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.utility.Media;
import com.b3dgs.lionengine.utility.Timer;
import java.awt.Graphics2D;

public class Intro extends Sequence {

    private final Sprite[] surfaces;
    private final Timer pause;
    private int alpha, id, n;

    public Intro(Loader loader) {
        super(loader);
        this.surfaces = new Sprite[3];
        this.pause = new Timer();
    }

    @Override
    protected void load() {
        this.surfaces[0] = Drawable.DRAWABLE.loadSprite(Media.get("pics", "epic.png"));
        this.surfaces[1] = Drawable.DRAWABLE.loadSprite(Media.get("pics", "eclipse.png"));
        this.surfaces[2] = Drawable.DRAWABLE.loadSprite(Media.get("pics", "b3dgs.png"));
        for (int i = 0; i < this.surfaces.length; i++) {
            this.surfaces[i].load(true);
        }
        this.alpha = 0;
        this.id = 0;
        this.screen.hideCursor();
    }

    @Override
    protected void update(float extrp) {
        if (this.keyboard.isPressed(Keyboard.ESCAPE)) {
            this.end(new Menu(this.loader));
        }
        switch (this.id) {
            case 0:
                this.updateAlpha(true, 0);
                break;
            case 1:
                this.updateAlpha(false, 0);
                break;
            case 2:
                this.updateAlpha(true, 1);
                break;
            case 3:
                this.updateAlpha(false, 1);
                break;
            case 4:
                this.updateAlpha(true, 2);
                break;
            case 5:
                this.updateAlpha(false, 2);
                break;
            case 6:
                this.end(new Menu(this.loader));
        }
    }

    private void updateAlpha(boolean in, int n) {
        if (in) {
            this.alpha += 6;
            if (this.alpha > 255) {
                this.alpha = 255;
                this.id++;
                this.pause.start();
            }
        } else if (this.pause.elapsed(1000)) {
            this.alpha -= 6;
            if (this.alpha < 0) {
                this.alpha = 0;
                this.id++;
            }
        }
        this.n = n;
    }

    @Override
    protected void render(Graphics2D g) {
        g.clearRect(0, 0, this.width, this.height);
        this.surfaces[this.n].setAlpha(this.alpha);
        this.surfaces[this.n].render(g, 0, 0);
    }

    @Override
    protected void terminate() {
    }
}
