package com.b3dgs.tyrian;

import com.b3dgs.lionengine.engine.Loader;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.utility.Maths;
import com.b3dgs.lionengine.utility.Media;
import java.awt.Graphics2D;

public class Scene extends AbstractSequence {

    private final World world;

    public Scene(Loader loader) {
        super(loader);
        this.world = new World(this.screen);
    }

    @Override
    protected void load() {
        this.world.loadFromFile(Media.get("levels", Maths.random(0, 1) + ".map"));
        this.screen.hideCursor();
        try {
            Thread.sleep(100);
        } catch (InterruptedException ex) {
        }
    }

    @Override
    protected void update(float extrp) {
        super.update(extrp);
        this.world.update(this.keyboard, this.mouse, extrp);
        if (this.keyboard.isPressed(Keyboard.ESCAPE)) {
            this.end(new Menu(this.loader));
        }
    }

    @Override
    protected void render(Graphics2D g) {
        this.world.render(g);
        super.render(g);
    }

    @Override
    protected void terminate() {
        this.world.inGame.stopMusic();
    }

    @Override
    public void onLostFocus() {
        this.world.inGame.pause();
    }

    @Override
    public void onGainedFocus() {
        this.world.inGame.unpause();
    }
}
