package com.b3dgs.tyrian.bonus;

import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.tyrian.EntitiesHandler;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.effect.Score;
import com.b3dgs.tyrian.gameplay.AbstractBonus;
import com.b3dgs.tyrian.gameplay.Ship;

public class BonusCoin extends AbstractBonus {

    private static final int FRAMES = 6;
    private static final float SPEED = 0.4f;
    private final RessourcesHandler rh;
    private final EntitiesHandler handler;
    public final int score, scoreTile, frames;

    public BonusCoin(RessourcesHandler rh, EntitiesHandler handler, int tile, int score, int scoreTile, int frames) {
        super(rh.getTiledSprite(ListRessources.Bonus1), tile);
        this.rh = rh;
        this.handler = handler;
        this.scoreTile = scoreTile;
        this.frames = frames;
        this.score = score;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        super.update(keyboard, mouse, extrp);
        this.updateCollision(0, 0, 12, 14);
        this.frame = (this.frame + SPEED) % FRAMES;
    }

    @Override
    public void giveBonus(Ship ship) {
        ship.money.increase(this.score);
        Score s = new Score(this.rh, this.scoreTile, this.frames);
        s.start(this.getX(), this.getY());
        this.handler.addQueue(s);
        SoundManager.play(SoundManager.SFX.ITEM);
    }
}
