package com.b3dgs.tyrian.bonus;

import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.AbstractBonus;
import com.b3dgs.tyrian.gameplay.Ship;

public class PowerUp extends AbstractBonus {

    private static final float SPEED = 0.1f;
    private boolean reverse;

    public PowerUp(RessourcesHandler rh) {
        super(rh.getTiledSprite(ListRessources.Bonus2), 18);
        this.reverse = false;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        super.update(keyboard, mouse, extrp);
        this.updateCollision(4, 8, 16, 12);
        if (!this.reverse) {
            this.frame += SPEED;
            if (this.frame > 5.5f) {
                this.reverse = true;
            }
        } else {
            this.frame -= SPEED;
            if (this.frame < 0.5f) {
                this.reverse = false;
            }
        }
    }

    @Override
    public void giveBonus(Ship ship) {
        if (ship.frontWeapon.level.getPercent() <= ship.rearWeapon.level.getPercent() || ship.rearWeapon.level.isEmpty()) {
            ship.frontWeapon.level.increase(1);
        } else {
            ship.rearWeapon.level.increase(1);
        }
        SoundManager.play(SoundManager.SFX.POWERUP);
    }
}
