package com.b3dgs.tyrian.effect;

import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import java.awt.Graphics2D;

public class BulletHit extends AbstractShmupEntity {
    
    private float frame;
    private boolean played;
    
    public BulletHit(RessourcesHandler rh) {
        super(rh.getTiledSprite(ListRessources.BulletHit));
    }
    
    public void start(int x, int y) {
        this.x = x;
        this.y = y;
        this.frame = 0.0f;
        this.played = false;
    }
    
    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        if (!this.played) {
            SoundManager.play(SoundManager.SFX.BULLET_HIT);
            this.played = true;
        }
        this.frame += 0.2f;
        if (this.frame >= this.surface.getTilesNumber() - 0.5f) {
            this.frame = this.surface.getTilesNumber();
            this.destroy();
        }
    }
    
    @Override
    public void render(Graphics2D g, Camera camera) {
        this.surface.render(g, (int) this.frame, (int) this.x - camera.getX(), camera.getY() - (int) this.y + 4);
    }
}
