package com.b3dgs.tyrian.effect;

import com.b3dgs.lionengine.drawable.TiledSprite;
import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.SoundManager;
import java.awt.Graphics2D;

public class Explode extends AbstractShmupEntity {

    private float frame;
    private final Timer timerDelay;
    private long delay;
    private boolean played;

    public Explode(TiledSprite anim) {
        super(anim);
        this.timerDelay = new Timer();
    }

    public void start(int x, int y, long delay) {
        this.x = x;
        this.y = y;
        this.frame = 0.0f;
        this.timerDelay.start();
        this.delay = delay;
        this.played = false;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        if (this.delay == 0 || this.timerDelay.elapsed(this.delay)) {
            if (!this.played) {
                SoundManager.play(SoundManager.SFX.EXPLODE_LARGE);
                this.played = true;
            }
            this.frame += 0.5f;
            if (this.frame >= this.surface.getTilesNumber()) {
                this.frame = this.surface.getTilesNumber();
                this.destroy();
            }
        }
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        if (this.delay == 0 || this.timerDelay.elapsed(this.delay)) {
            this.surface.render(g, (int) this.frame, (int) this.x - camera.getX(), camera.getY() - (int) this.y);
        }
    }
}
