package com.b3dgs.tyrian.effect;

import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import java.awt.Graphics2D;

public class Score extends AbstractShmupEntity {

    private static final float SPEED = 0.1f;
    private static final long TIME = 500L;
    private final int tile, frames;
    private final Timer timer;
    private float frame;

    public Score(RessourcesHandler rh, int tile, int frames) {
        super(rh.getTiledSprite(ListRessources.Scores));
        this.tile = tile;
        this.frames = frames - 1;
        this.timer = new Timer();
        this.frame = 0.0f;
    }

    public void start(int x, int y) {
        this.x = x;
        this.y = y;
        this.timer.start();
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        this.frame += SPEED;
        if (this.frame > this.frames) {
            this.frame = this.frames;
        }
        if (this.timer.elapsed(TIME)) {
            this.destroy();
        }
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.surface.render(g, (int) this.frame + this.tile, (int) this.x - camera.getX(), camera.getY() - (int) this.y);
    }
}
