package com.b3dgs.tyrian.effect;

import com.b3dgs.lionengine.Drawable;
import com.b3dgs.lionengine.drawable.AnimState;
import com.b3dgs.lionengine.drawable.Animator;
import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import java.awt.Graphics2D;

public class Smoke extends AbstractShmupEntity {

    private final Animator anim;

    public Smoke(RessourcesHandler rh) {
        super(rh.getTiledSprite(ListRessources.Smoke));
        this.anim = Drawable.DRAWABLE.createAnimator();
    }

    public void start(int x, int y) {
        this.x = x;
        this.y = y;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        this.anim.play(1, 8, 0.5f, false, false);
        if (this.anim.getAnimState() == AnimState.FINISHED) {
            this.destroy();
        }
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.surface.render(g, this.anim.getFrame(), (int) this.x - camera.getX(), camera.getY() - (int) this.y + 12);
    }
}
