package com.b3dgs.tyrian.entity.layer1;

import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.gameplay.AbstractLayerEntity;

public abstract class AbstractLayer1Entity extends AbstractLayerEntity {

    protected boolean noMove;
    private int offsetX;

    public AbstractLayer1Entity(RessourcesHandler rh, EffectHandler handler, int id, int tile, int cx, int cy, int cw, int ch, int x, int y) {
        super(rh, handler, id, tile, cx, cy, cw, ch);
        this.place(x * 24, (y - 6) * 28 - 4);
        this.setCanHit(false);
        this.life.setMax(100);
        this.life.fill();
        this.noMove = false;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        this.backupCoord();
        if (!this.noMove) {
            this.move(0, -0.75f);
        }
        this.noMove = false;
        this.updateCollision(this.cx + this.offsetX, this.cy, this.cw, this.ch);
    }

    public void skipMove() {
        this.noMove = true;
    }

    public void setOffsetX(int x) {
        this.offsetX = x;
    }
}
