package com.b3dgs.tyrian.entity.layer1.level1;

import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.EntitiesHandler;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.entity.layer1.AbstractLayer1Entity;
import java.awt.Graphics2D;

public class DoubleCannon extends AbstractLayer1Entity {

    private final EntitiesHandler entitys;
    private final float speed;
    private Timer shoot;

    public DoubleCannon(RessourcesHandler rh, EntitiesHandler entitys, EffectHandler handler, int x, int y) {
        super(rh, handler, 0, 67, 4, 2, 16, 24, x, y);
        this.entitys = entitys;
        this.shoot = new Timer();
        this.shoot.start();
        this.speed = 3.0f;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        super.update(keyboard, mouse, extrp);
        this.anim.play(0, 2, 0.1f, true, true);
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.renderFrame(g, camera, this.anim.getFrame(), 0, 0);
    }

    @Override
    protected void explode(int minX, int maxX, int minY, int maxY, int sprite, int max) {
        super.explode(-12, 12, -14, 14, 1, 4);
    }
}
