package com.b3dgs.tyrian.entity.layer1.level1;

import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.lionengine.utility.Maths;
import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.EntitiesHandler;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.entity.layer1.AbstractLayer1Entity;
import com.b3dgs.tyrian.gameplay.bullet.EntityBullet;
import java.awt.Graphics2D;

public class GreenPulse extends AbstractLayer1Entity {

    private final EntitiesHandler entitys;
    private final float speed;
    private Timer shoot;

    public GreenPulse(RessourcesHandler rh, EntitiesHandler entitys, EffectHandler handler, int x, int y) {
        super(rh, handler, 0, 108, 4, 0, 16, 16, x, y);
        this.entitys = entitys;
        this.shoot = new Timer();
        this.shoot.start();
        this.speed = 3.0f;
        this.life.setMax(75);
        this.life.fill();
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        super.update(keyboard, mouse, extrp);

        this.anim.play(0, 2, 0.1f, true, true);
        if (!this.noMove && this.shoot.elapsed(500)) {
            float x1 = this.ship.getXOffset() + this.ship.getX() + this.ship.getWidth() / 2;
            float x2 = this.getX() + this.getWidth() / 2;
            float y1 = this.ship.getYOffset() + this.ship.getY() + this.ship.getHeight() / 2 + 16;
            float y2 = -this.getY() + this.getHeight() / 2;
            float dist = Maths.getDistance(x1, y1, x2, y2);

            if (y2 < 228 && y2 > -28) {
                if (this.anim.getFrame() > 1) {
                    float vx = ((x1 - x2) / dist) * this.speed;
                    float vy = ((y2 - y1) / dist) * this.speed;
                    EntityBullet b = new EntityBullet(this.rh, -1, 196, this.handler);
                    b.start(this, vx, vy);
                    b.move(4, -2);
                    this.entitys.add(b);
                    this.shoot.start();
                }
            }
        }
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.renderFrame(g, camera, this.anim.getFrame(), 0, 0);
    }

    @Override
    protected void explode(int minX, int maxX, int minY, int maxY, int sprite, int max) {
        super.explode(-12, 12, -14, 14, 1, 4);
    }
}
