package com.b3dgs.tyrian.entity.layer2.level1;

import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.lionengine.utility.Maths;
import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import java.awt.Graphics2D;

public class Armory extends AbstractShmupEntity {

    private final Timer buy, timer;
    private boolean appearing, bought, willAppear;
    private float toY;

    public Armory(RessourcesHandler rh, EffectHandler handler) {
        super(rh.getTiledSprite(ListRessources.Armory));
        this.invertYAxis(true);
        this.setDestructible(false);
        this.buy = new Timer();
        this.timer = new Timer();
        this.appearing = false;
        this.place(64, -224);
    }

    public void appear() {
        this.willAppear = true;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        if (!this.appearing && this.willAppear) {
            this.place(Maths.random(-32, 150), 224);
            this.appearing = true;
            this.bought = false;
            this.willAppear = false;
            this.timer.start();
            this.toY = 0.0f;
        }
        this.backupCoord();
        if (this.appearing) {
            if (this.getY() > 48 && !this.bought) {
                this.setY(Maths.curveValue(this.getYReal(), -64, 128.0f));
            } else {
                this.toY -= 0.05f;
                this.setY(this.getYReal() + this.toY);
            }
            if (this.getY() < -224) {
                this.appearing = false;
                this.buy.start();
            }
        }
        this.updateCollision(80, 100, 30, 70);
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.surface.render(g, 0, (int) this.x - camera.getX(), (int) Math.floor(camera.getY() - this.y));
    }

    public void bought() {
        this.bought = true;
    }

    public boolean canBuy() {
        return this.appearing && !this.bought;
    }
}
