package com.b3dgs.tyrian.entity.layer2.level1;

import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.gameplay.AbstractLayerEntity;

public class EntityLayer2Factory {

    private final ListEntityLayer2Level1[] entities = ListEntityLayer2Level1.values();
    private final RessourcesHandler rh;
    private final EffectHandler effects;

    public EntityLayer2Factory(RessourcesHandler rh, EffectHandler effects) {
        this.rh = rh;
        this.effects = effects;
    }

    public AbstractLayerEntity createEntity(ListEntityLayer2Level1 entity) {
        switch (entity) {
            case MeteorLarge:
                return new MeteorLarge(this.rh, this.effects);
            case MeteorMedium:
                return new MeteorMedium(this.rh, this.effects);
            case MeteorSmall:
                return new MeteorSmall(this.rh, this.effects);
            default:
                return null;
        }
    }
}
