package com.b3dgs.tyrian.entity.layer2.level1;

import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.gameplay.AbstractLayerEntity;
import java.awt.Graphics2D;

public class MeteorLarge extends AbstractLayerEntity {

    public MeteorLarge(RessourcesHandler rh, EffectHandler handler) {
        super(rh, handler, 1, 24, 6, 18, 60, 56);
        this.life.setMax(300);
        this.life.fill();
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.renderFrame(g, camera, 0, 0, 0);
        this.renderFrame(g, camera, 1, 1, 0);
        this.renderFrame(g, camera, 2, 2, 0);
        this.renderFrame(g, camera, 8, 0, 1);
        this.renderFrame(g, camera, 9, 1, 1);
        this.renderFrame(g, camera, 10, 2, 1);
        this.renderFrame(g, camera, 16, 0, 2);
        this.renderFrame(g, camera, 17, 1, 2);
        this.renderFrame(g, camera, 18, 2, 2);
    }

    @Override
    public void destroy() {
        super.destroy();
        if (this.getY() <= -200) {
            this.ship.earth.decrease(10);
        }
    }

    @Override
    protected void explode(int minX, int maxX, int minY, int maxY, int sprite, int max) {
        super.explode(-10, 60, -8, 64, 1, 32);
        this.ship.money.increase(300);
    }
}
