package com.b3dgs.tyrian.equip;

import com.b3dgs.lionengine.drawable.TiledSprite;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import java.awt.Graphics2D;

public class AbstractEquip implements Equip {
    
    private final TiledSprite surface;
    private final int id;
    private final int price;
    private final String name;
    
    public AbstractEquip(RessourcesHandler rh, int id, String name, int price) {
        this.surface = rh.getTiledSprite(ListRessources.Equipment);
        this.id = id;
        this.price = price;
        this.name = name;
    }
    
    @Override
    public void render(Graphics2D g, int x, int y) {
        this.surface.render(g, this.id, x, y);
    }

    @Override
    public String name() {
        return this.name;
    }

    @Override
    public int price() {
        return this.price;
    }

    @Override
    public int gfxID() {
        return this.id;
    }
}
