package com.b3dgs.tyrian.gameplay;

import com.b3dgs.lionengine.drawable.TiledSprite;
import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.input.Keyboard;
import com.b3dgs.lionengine.input.Mouse;
import java.awt.Color;
import java.awt.Graphics2D;

public abstract class AbstractBonus extends AbstractShmupEntity {

    protected final int tile;
    protected float frame;

    public AbstractBonus(TiledSprite surface, int tile) {
        super(surface);
        this.invertYAxis(true);
        this.tile = tile;
        this.frame = 0;
    }

    @Override
    public void update(Keyboard keyboard, Mouse mouse, float extrp) {
        this.backupCoord();
        this.move(this.getVecX(), this.getVecY());
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.surface.render(g, this.tile + (int) this.frame, (int) this.x - camera.getX(), camera.getY() - (int) this.y);
        g.setColor(Color.red);
    }

    @Override
    public void hitBy(AbstractShmupEntity entity) {
        if (entity instanceof Ship) {
            this.giveBonus((Ship) entity);
            this.destroy();
        }
    }

    public abstract void giveBonus(Ship ship);
}
