package com.b3dgs.tyrian.gameplay;

import com.b3dgs.lionengine.drawable.TiledSprite;
import com.b3dgs.lionengine.input.Mouse;
import com.b3dgs.tyrian.SoundManager;
import java.awt.Graphics2D;

public class AbstractMenuButton {

    private final TiledSprite surface;
    private final int id, x, y, width, height;
    private boolean over, overed;

    public AbstractMenuButton(TiledSprite surface, int id, int x, int y) {
        this.surface = surface;
        this.id = id;
        this.x = x;
        this.y = y;
        this.width = this.surface.getTileWidth();
        this.height = this.surface.getTileHeight();
    }

    public void update(Mouse mouse, int click, float extrp) {
        int mx = mouse.getOnWindowX();
        int my = mouse.getOnWindowY();
        if (mx >= this.x && mx <= this.x + this.width && my > this.y && my < this.y + this.height) {
            this.over = true;
            if (mouse.hasClickedOnce(click)) {
                this.onClick();
            }
            this.onOver();
        } else {
            this.over = false;
            this.overed = false;
        }
    }

    public void onClick() {
        SoundManager.play(SoundManager.SFX.WEAPON_PULSE);
    }

    public void render(Graphics2D g) {
        if (this.over) {
            this.surface.render(g, this.id + 1, this.x, this.y);
        } else {
            this.surface.render(g, this.id, this.x, this.y);
        }
    }

    public void onOver() {
        if (!this.overed) {
            SoundManager.play(SoundManager.SFX.SELECT);
            this.overed = true;
        }
    }
}
