package com.b3dgs.tyrian.gameplay;

import com.b3dgs.lionengine.game.shmup.AbstractBullet;
import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.effect.BulletHit;
import com.b3dgs.tyrian.gameplay.bullet.EntityBullet;

public abstract class BulletModel extends AbstractBullet {

    protected final RessourcesHandler rh;
    protected final EffectHandler effects;

    public BulletModel(RessourcesHandler rh, int id, int frame, EffectHandler handler) {
        super(rh.getTiledSprite(ListRessources.Weapons), id, frame);
        this.rh = rh;
        this.effects = handler;
        this.invertYAxis(true);
    }

    @Override
    public void updateCollision(int offsetX, int offsetY) {
        super.updateCollision(0, 0);
    }

    @Override
    public void onHit(AbstractShmupEntity entity) {
        BulletHit b = new BulletHit(this.rh);
        b.start(this.getX(), this.getY());
        this.effects.addQueue(b);
        if (!(this instanceof EntityBullet) || entity instanceof Ship) {
            this.destroy();
        }
    }
}
