package com.b3dgs.tyrian.gameplay.bullet;

import com.b3dgs.lionengine.Drawable;
import com.b3dgs.lionengine.drawable.Animator;
import com.b3dgs.lionengine.game.Camera;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.gameplay.BulletModel;
import java.awt.Graphics2D;

public class EntityBullet extends BulletModel {

    private final Animator anim;

    public EntityBullet(RessourcesHandler rh, int id, int frame, EffectHandler handler) {
        super(rh, id, frame, handler);
        this.setDestructible(false);
        this.anim = Drawable.DRAWABLE.createAnimator();
    }

    @Override
    protected void updateMove() {
        this.move(this.getVecX(), this.getVecY());
        this.anim.play(1, 3, 0.2f, true, true);
    }

    @Override
    public void render(Graphics2D g, Camera camera) {
        this.surface.render(g, this.frame + this.anim.getFrame() - 1, (int) this.x - camera.getX(), camera.getY() - (int) this.y);
    }
}
