package com.b3dgs.tyrian.gameplay.bullet;

import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.effect.Smoke;

public class HeavyMissileBullet extends MissileBullet {

    private final Timer smoke;

    public HeavyMissileBullet(RessourcesHandler rh, int id, int frame, EffectHandler handler) {
        super(rh, id, frame, handler);
        this.smoke = new Timer();
    }

    @Override
    protected void updateMove() {
        this.move(this.getVecX(), this.getVecY());
        this.setVect(this.getVecX() * 1.05f, this.getVecY() * 1.05f);
        if (this.smoke.elapsed(40)) {
            Smoke s = new Smoke(this.rh);
            s.start(this.getX(), this.getY() + 10);
            this.effects.addQueue(s);
            this.smoke.start();
        }
    }
}
