package com.b3dgs.tyrian.gameplay.bullet;

import com.b3dgs.lionengine.game.shmup.AbstractShmupEntity;
import com.b3dgs.lionengine.game.shmup.EffectHandler;
import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.effect.Explode;
import com.b3dgs.tyrian.effect.Smoke;
import com.b3dgs.tyrian.gameplay.BulletModel;

public class MissileBullet extends BulletModel {

    private final Timer smoke;

    public MissileBullet(RessourcesHandler rh, int id, int frame, EffectHandler handler) {
        super(rh, id, frame, handler);
        this.smoke = new Timer();
        this.smoke.start();
    }

    @Override
    protected void updateMove() {
        this.move(this.getVecX(), this.getVecY());
        this.setVect(this.getVecX(), this.getVecY() * 1.05f);
        if (this.smoke.elapsed(40)) {
            Smoke s = new Smoke(this.rh);
            s.start(this.getX(), this.getY());
            this.effects.addQueue(s);
            this.smoke.start();
        }
    }

    @Override
    public void onHit(AbstractShmupEntity entity) {
        super.onHit(entity);
        for (int i = -2; i < 3; i++) {
            Explode e = new Explode(this.rh.getTiledSprite(ListRessources.Explode3));
            e.start(this.getX() + i * 8, this.getY(), Math.abs(i) * 40);
            this.effects.addQueue(e);
        }
        for (int i = -2; i < 3; i++) {
            Explode e = new Explode(this.rh.getTiledSprite(ListRessources.Explode3));
            e.start(this.getX(), this.getY() + i * 8, Math.abs(i) * 40);
            this.effects.addQueue(e);
        }
    }
}
