package com.b3dgs.tyrian.weapon;

import com.b3dgs.lionengine.drawable.TiledSprite;
import com.b3dgs.lionengine.game.shmup.AbstractWeapon;
import com.b3dgs.tyrian.ListRessources;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.equip.Equip;
import com.b3dgs.tyrian.gameplay.ListBullet;
import com.b3dgs.tyrian.gameplay.Ship;
import java.awt.Graphics2D;

public abstract class Weapon extends AbstractWeapon<Ship, ListBullet> implements Equip {

    private final String name;
    private final int gfxID, price;
    private final TiledSprite surface;
    protected final ListBullet l, c, m, h;
    protected boolean front;

    public Weapon(RessourcesHandler rh, String name, int gfxID, int price) {
        super(rh.phFront, rh.bulletFactory);
        this.surface = rh.getTiledSprite(ListRessources.Equipment);
        this.name = name;
        this.gfxID = gfxID;
        this.price = price;
        this.level.setMax(6);
        this.level.set(1);
        this.setYOffset(-16);
        this.l = ListBullet.Linear;
        this.c = ListBullet.Curved;
        this.m = ListBullet.Missile;
        this.h = ListBullet.HeavyMissile;
        this.front = true;
    }

    @Override
    public void render(Graphics2D g, int x, int y) {
        this.surface.render(g, this.gfxID, x, y);
    }

    @Override
    public String name() {
        return this.name;
    }

    @Override
    public int price() {
        return this.price;
    }

    @Override
    public int gfxID() {
        return this.gfxID;
    }

    public boolean isFront() {
        return this.front;
    }
}
