package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class HeavyMissilesFront extends Weapon {

    private static final int FRAME = 121;
    private final float speed;

    public HeavyMissilesFront(RessourcesHandler rh) {
        super(rh, "Front Heavy Missiles", 10, 1000);
        this.speed = 1.0f;
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 80;
        this.setRate(400);
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                this.setEnergy(75);
                this.addBullet(ship, this.h, dmg, FRAME, 0.0f, this.speed * 0.6f, 0, -8);
                break;
            case 2:
                dmg += 15;
                this.setEnergy(85);
                this.addBullet(ship, this.m, dmg, FRAME + 1, 0.0f, this.speed, -6, -8);
                this.addBullet(ship, this.m, dmg, FRAME + 1, 0.0f, this.speed, 6, -8);
                break;
            case 3:
                dmg += 25;
                this.setEnergy(95);
                this.addBullet(ship, this.m, dmg, FRAME + 2, 0.0f, this.speed, -6, -8);
                this.addBullet(ship, this.m, dmg, FRAME + 2, 0.0f, this.speed, 6, -8);
                break;
            case 4:
                this.setEnergy(115);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed * 0.9f, -10, -4);
                this.addBullet(ship, this.m, dmg + 25, FRAME + 2, 0.0f, this.speed, 0, -8);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed * 0.9f, 10, -4);
                break;
            case 5:
                this.setEnergy(125);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed * 0.9f, -12, -4);
                this.addBullet(ship, this.m, dmg + 25, FRAME + 2, 0.0f, this.speed, -6, -8);
                this.addBullet(ship, this.m, dmg + 25, FRAME + 2, 0.0f, this.speed, 6, -8);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed * 0.9f, 12, -4);
                break;
            case 6:
                this.setEnergy(140);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed * 0.8f, -20, 0);
                this.addBullet(ship, this.m, dmg + 15, FRAME + 1, 0.0f, this.speed * 0.9f, -10, -4);
                this.addBullet(ship, this.m, dmg + 25, FRAME + 2, 0.0f, this.speed, 0, -8);
                this.addBullet(ship, this.m, dmg + 15, FRAME + 1, 0.0f, this.speed * 0.9f, 10, -4);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed * 0.8f, 20, 0);
                break;

        }
        SoundManager.play(SoundManager.SFX.WEAPON_MISSILE);
    }
}
