package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class HyperPulse extends Weapon {

    private static final int FRAME = 0;
    private final float speed;

    public HyperPulse(RessourcesHandler rh) {
        super(rh, "Hyper Pulse", 2, 800);
        this.speed = 4.0f;
    }

    @Override
    protected void fire(Ship ship) {
        int dmg;
        this.setRate(125);
        this.setCollision(0, 1, 0, 1);
        switch (this.level.getCurrent()) {
            case 1:
                dmg = 25;
                this.setEnergy(30);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, 0, 0);
                break;
            case 2:
                dmg = 20;
                this.setEnergy(35);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 12, this.speed * 0.92f, 0, 0);
                break;
            case 3:
                dmg = 18;
                this.setEnergy(40);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 12, this.speed * 0.92f, 0, 0);
                break;
            case 4:
                dmg = 16;
                this.setEnergy(50);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 6, this.speed * 0.85f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 6, this.speed * 0.85f, 0, 0);
                break;
            case 5:
                dmg = 14;
                this.setEnergy(60);
                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 5, this.speed * 0.78f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 6, this.speed * 0.85f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 6, this.speed * 0.85f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 5, this.speed * 0.78f, 0, 0);
                break;
            case 6:
                dmg = 12;
                this.setEnergy(70);
                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, this.speed * 0.72f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 5, this.speed * 0.78f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 6, this.speed * 0.85f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 12, this.speed * 0.92f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 6, this.speed * 0.85f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 5, this.speed * 0.78f, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, this.speed * 0.72f, 0, 0);
                break;
        }
        SoundManager.play(SoundManager.SFX.WEAPON_PULSE);
    }
}
