package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.lionengine.utility.Timer;
import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class Laser extends Weapon {

    private static final int FRAME = 177;
    private final float speed;
    private final Timer snd;

    public Laser(RessourcesHandler rh) {
        super(rh, "Laser", 26, 1500);
        this.speed = 8.0f;
        this.snd = new Timer();
        this.snd.start();
    }

    private void laser(Ship ship, int dmg, int of, int ox) {
        this.addBullet(ship, this.l, dmg, FRAME + of, 0.0f, this.speed, ox, -28);
        this.addBullet(ship, this.l, dmg, FRAME + of, 0.0f, this.speed, ox, -14);
        this.addBullet(ship, this.l, dmg, FRAME + of, 0.0f, this.speed, ox, 0);
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 3;
        this.setRate(30);
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                this.setEnergy(14);
                this.laser(ship, dmg, -15, 0);
                break;
            case 2:
                this.setEnergy(16);
                this.laser(ship, dmg + 1, -14, 0);
                break;
            case 3:
                this.setEnergy(18);
                this.laser(ship, dmg + 2, -13, 0);
                break;
            case 4:
                this.setEnergy(20);
                this.laser(ship, dmg, -15 + 15, -9);
                this.laser(ship, dmg + 3, -13, 0);
                this.laser(ship, dmg, -15 + 15, 8);
                break;
            case 5:
                this.setEnergy(24);
                this.laser(ship, dmg + 1, -14 - 15, -11);
                this.laser(ship, dmg + 3, -13, 0);
                this.laser(ship, dmg + 1, -14 - 15, 10);
                break;
            case 6:
                this.setEnergy(28);
                this.laser(ship, dmg + 2, -13 - 15, -11);
                this.laser(ship, dmg + 3, -13 - 15, 0);
                this.laser(ship, dmg + 2, -13 - 15, 11);
                break;
        }
        if (this.snd.elapsed(800)) {
            SoundManager.play(SoundManager.SFX.WEAPON_LASER);
            this.snd.start();
        }
    }
}
