package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class MissileLauncher extends Weapon {

    private static final int FRAME = 120;
    private final float speed;

    public MissileLauncher(RessourcesHandler rh) {
        super(rh, "Missile Launcher", 9, 900);
        this.speed = 1.5f;
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 60;
        this.setRate(300);
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                this.setEnergy(60);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed, 0, -12);
                break;
            case 2:
                this.setEnergy(70);
                this.addBullet(ship, this.m, dmg, FRAME, -this.speed / 8, this.speed, -2, -12);
                this.addBullet(ship, this.m, dmg, FRAME, this.speed / 8, this.speed, 2, -12);
                break;
            case 3:
                this.setEnergy(80);
                this.addBullet(ship, this.m, dmg, FRAME, -this.speed / 7, this.speed * 0.9f, -2, -10);
                this.addBullet(ship, this.m, dmg, FRAME, 0.0f, this.speed, 0, -14);
                this.addBullet(ship, this.m, dmg, FRAME, this.speed / 7, this.speed * 0.9f, 2, -10);
                break;
            case 4:
                this.setEnergy(95);
                this.addBullet(ship, this.m, dmg, FRAME, -this.speed / 6, this.speed * 0.9f, -8, -10);
                this.addBullet(ship, this.m, dmg, FRAME, -this.speed / 8, this.speed, -2, -14);
                this.addBullet(ship, this.m, dmg, FRAME, this.speed / 8, this.speed, 2, -14);
                this.addBullet(ship, this.m, dmg, FRAME, this.speed / 6, this.speed * 0.9f, 8, -10);
                break;
            case 5:
                this.setEnergy(115);
                this.addBullet(ship, this.m, dmg + 20, FRAME + 15, 0.0f, this.speed, -6, -12);
                this.addBullet(ship, this.m, dmg + 20, FRAME + 15, 0.0f, this.speed, 6, -12);
                break;
            case 6:
                this.setEnergy(135);
                this.addBullet(ship, this.m, dmg, FRAME, -this.speed / 6, this.speed * 0.84f, -8, -10);
                this.addBullet(ship, this.m, dmg, FRAME, -this.speed / 8, this.speed * 0.92f, -2, -14);
                this.addBullet(ship, this.m, dmg + 20, FRAME + 15, 0.0f, this.speed, 0, -16);
                this.addBullet(ship, this.m, dmg, FRAME, this.speed / 8, this.speed * 0.92f, 2, -14);
                this.addBullet(ship, this.m, dmg, FRAME, this.speed / 6, this.speed * 0.84f, 8, -10);
                break;
        }
        SoundManager.play(SoundManager.SFX.WEAPON_MISSILE);
    }
}
