package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class MultiCannon extends Weapon {

    private static final int FRAME = 62;
    private final float speed;

    public MultiCannon(RessourcesHandler rh) {
        super(rh, "Multi Cannon", 3, 1000);
        this.speed = 4.0f;
    }

    @Override
    protected void fire(Ship ship) {
        this.setRate(175);
        this.setCollision(0, 1, 0, 1);
        int dmg = 16;
        switch (this.level.getCurrent()) {
            case 1:
                this.setEnergy(50);
                this.addBullet(ship, this.l, dmg, FRAME + 2, -this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 3, this.speed / 2, this.speed, 0, 0);
                break;
            case 2:
                this.setEnergy(60);
                this.addBullet(ship, this.l, dmg, FRAME + 2, -this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, 0, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 3, this.speed / 2, this.speed, 0, 0);
                break;
            case 3:
                this.setEnergy(70);
                this.addBullet(ship, this.l, dmg, FRAME - 2, -this.speed, this.speed / 2, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 2, -this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, 0, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 3, this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME - 1, this.speed, this.speed / 2, 0, 0);
                break;
            case 4:
                this.setEnergy(80);
                this.addBullet(ship, this.l, dmg, FRAME - 2, -this.speed, this.speed / 2, 0, 0);
                this.addBullet(ship, this.l, dmg + 15, FRAME + 30, -this.speed, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 2, -this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, 1, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 3, this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 15, FRAME + 31, this.speed, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg, FRAME - 1, this.speed, this.speed / 2, 0, 0);
                break;
            case 5:
                this.setEnergy(90);
                this.addBullet(ship, this.l, dmg + 30, FRAME + 4, -this.speed, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 30, FRAME + 5, this.speed, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 30, FRAME + 5 + 30, 0.0f, this.speed, 0, 0);
                break;
            case 6:
                this.setEnergy(100);
                this.addBullet(ship, this.l, dmg + 10, FRAME + 2, -this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 10, FRAME + 3, this.speed / 2, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 10, FRAME + 2, -this.speed / 2, this.speed, 6, 0);
                this.addBullet(ship, this.l, dmg + 10, FRAME + 3, this.speed / 2, this.speed, -6, 0);

                this.addBullet(ship, this.l, dmg + 30, FRAME + 4, -this.speed, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 30, FRAME + 5, this.speed, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 30, FRAME + 5 + 30, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, dmg + 30, FRAME - 2 + 30, -this.speed, this.speed / 2, 0, 0);
                this.addBullet(ship, this.l, dmg + 30, FRAME - 1 + 30, this.speed, this.speed / 2, 0, 0);
                break;
        }
        SoundManager.play(SoundManager.SFX.WEAPON_PULSE);
    }
}
