package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class Proton extends Weapon {

    private static final int FRAME = 139;
    private final float speed;

    public Proton(RessourcesHandler rh) {
        super(rh, "Proton", 14, 600);
        this.speed = 5.0f;
    }

    private void pDouble(Ship ship, int dmg, int of, int ox) {
        this.addBullet(ship, this.l, dmg, FRAME + of, 0.0f, this.speed, -ox, 0);
        this.addBullet(ship, this.l, dmg, FRAME + of, 0.0f, this.speed, ox, 0);
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 25;
        this.setRate(275);
        this.setCollision(0, 1, 0, 0.5f);
        int lvl = this.level.getCurrent();
        switch (lvl) {
            case 1:
                this.setEnergy(90);
                this.pDouble(ship, dmg, 0, 3);
                break;
            case 2:
                this.setEnergy(95);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 6, this.speed * 0.9f, 0, -8);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, 0, -8);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 6, this.speed * 0.9f, 0, -8);
                break;
            case 3:
                this.setEnergy(105);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 5, this.speed, -4, -8);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 8, this.speed * 0.9f, -2, -8);

                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 8, this.speed * 0.9f, 2, -8);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 5, this.speed, 4, -8);
                break;
            case 4:
                this.setEnergy(120);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 2, this.speed * 0.8f, -4, -8);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 4, this.speed * 0.9f, -2, -9);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, 0, -10);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 4, this.speed * 0.9f, 2, -9);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 2, this.speed * 0.8f, 4, -8);
                break;
            case 5:
                this.setEnergy(140);
                this.addBullet(ship, this.l, dmg, FRAME, -this.speed / 2, this.speed * 0.7f, -10, -4);
                this.addBullet(ship, this.l, dmg + 10, FRAME + 2, -this.speed / 4, this.speed * 0.8f, -6, -2);
                this.pDouble(ship, dmg + 15, 3, 6);
                this.addBullet(ship, this.l, dmg + 10, FRAME + 2, this.speed / 4, this.speed * 0.8f, 6, -2);
                this.addBullet(ship, this.l, dmg, FRAME, this.speed / 2, this.speed * 0.7f, 10, -4);
                break;
            case 6:
                this.setEnergy(160);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 3, -this.speed / 3, this.speed * 0.6f, -6, 0);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 3, -this.speed / 4, this.speed * 0.8f, -4, -4);
                this.addBullet(ship, this.l, dmg, FRAME + 1, -this.speed / 8, this.speed * 0.9f, -2, -2);

                this.addBullet(ship, this.l, dmg + 20, FRAME + 3, 0.0f, this.speed, 0, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 1, this.speed / 8, this.speed * 0.9f, 2, -2);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 3, this.speed / 4, this.speed * 0.8f, 4, -4);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 3, this.speed / 3, this.speed * 0.6f, 6, 0);
                break;
        }
        SoundManager.play(SoundManager.SFX.WEAPON_PROTON);
    }
}
