package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class PulseCannon extends Weapon {

    private static final int FRAME = 1;
    private int lvl4ID = 0, lvl5ID, lvl6ID;
    private final float speed;

    public PulseCannon(RessourcesHandler rh) {
        super(rh, "Pulse Cannon", 2, 600);
        this.speed = 4.0f;
    }

    @Override
    protected void fire(Ship ship) {
        int dmg;
        this.setRate(175);
        this.setCollision(0, 1, 0, 0.5f);
        int lvl = this.level.getCurrent();
        switch (lvl) {
            case 4:
                dmg = 60;
                this.setEnergy(65);
                this.addBullet(ship, this.l, this.lvl4ID, dmg, 1, 0.0f, this.speed, -6, 0); // top
                this.addBullet(ship, this.l, this.lvl4ID, dmg, 1, 0.0f, this.speed, 6, 0);  // top
                this.lvl4ID++;
                break;
            case 5:
                dmg = 70;
                this.setEnergy(85);
                this.addBullet(ship, this.l, this.lvl5ID, dmg, 0, 0.0f, this.speed, -12, 6);  // top
                this.addBullet(ship, this.l, this.lvl5ID, dmg, 0, 0.0f, this.speed, -8, 4);  // top
                this.addBullet(ship, this.l, this.lvl5ID, dmg, 0, 0.0f, this.speed, -4, 2); // top
                this.addBullet(ship, this.l, this.lvl5ID, dmg, 0, 0.0f, this.speed, 0, 0); // top
                this.addBullet(ship, this.l, this.lvl5ID, dmg, 0, 0.0f, this.speed, 4, 2);  // top
                this.addBullet(ship, this.l, this.lvl5ID, dmg, 0, 0.0f, this.speed, 8, 4);   // top
                this.addBullet(ship, this.l, this.lvl5ID, dmg, 0, 0.0f, this.speed, 12, 6);   // top
                this.lvl5ID++;
                break;
            case 6:
                dmg = 80;
                this.setEnergy(105);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, -23, 7);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, -18, 7);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, -13, 5);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, -8, 3);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 2, 0.0f, this.speed, 0, 0);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, 8, 3);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, 13, 5);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, 18, 7);
                this.addBullet(ship, this.l, this.lvl6ID, dmg, 0, 0.0f, this.speed, 23, 7);
                this.lvl6ID++;
                break;
            default:
                dmg = 20 + lvl * 10;
                this.setEnergy(40 + lvl * 8);
                this.addBullet(ship, this.l, dmg, FRAME + lvl - 1, 0.0f, this.speed, 0, 0); // top
        }
        SoundManager.play(SoundManager.SFX.WEAPON_PULSE);
    }
}
