package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class VulcanCannonFront extends Weapon {

    private static final int FRAME = 124;
    private static int offsetX;
    private int offsetMargin, offsetSpeed;
    private final float speed;

    public VulcanCannonFront(RessourcesHandler rh) {
        super(rh, "Front Vulcan Cannon", 7, 750);
        this.speed = 6.0f;
    }

    @Override
    protected void fire(Ship ship) {
        int dmg;
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                dmg = 16;
                this.setRate(90);
                this.setEnergy(20);
                this.offsetSpeed = 90;
                this.offsetMargin = 4;
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, (float) Math.sin(Math.toRadians(offsetX)) * this.offsetMargin, 0.0f);
                break;
            case 2:
                dmg = 19;
                this.setRate(80);
                this.setEnergy(18);
                this.offsetSpeed = 80;
                this.offsetMargin = 5;
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, this.speed, (float) Math.sin(Math.toRadians(offsetX)) * this.offsetMargin, 0.0f);
                break;
            case 3:
                dmg = 24;
                this.setRate(70);
                this.setEnergy(16);
                this.offsetSpeed = 80;
                this.offsetMargin = 5;
                this.addBullet(ship, this.l, dmg, FRAME + 1, 0.0f, this.speed, (float) Math.sin(Math.toRadians(offsetX)) * this.offsetMargin, 0.0f);
                break;
            case 4:
                dmg = 28;
                this.setRate(60);
                this.setEnergy(15);
                this.offsetSpeed = 70;
                this.offsetMargin = 6;
                this.addBullet(ship, this.l, dmg, FRAME + 1, 0.0f, this.speed, (float) Math.sin(Math.toRadians(offsetX)) * this.offsetMargin, 0.0f);
                break;
            case 5:
                dmg = 36;
                this.setRate(50);
                this.setEnergy(14);
                this.offsetSpeed = 65;
                this.offsetMargin = 7;
                this.addBullet(ship, this.l, dmg, FRAME + 2, 0.0f, this.speed, (float) Math.sin(Math.toRadians(offsetX)) * this.offsetMargin, 0.0f);
                break;
            case 6:
                dmg = 40;
                this.setRate(40);
                this.setEnergy(13);
                this.offsetSpeed = 60;
                this.offsetMargin = 8;
                this.addBullet(ship, this.l, dmg, FRAME + 3, 0.0f, this.speed, (float) Math.sin(Math.toRadians(offsetX)) * this.offsetMargin, 0.0f);
                break;
        }
        offsetX += this.offsetSpeed;
        offsetX %= 360;
        SoundManager.play(SoundManager.SFX.WEAPON_VULCAN);
    }
}
