package com.b3dgs.tyrian.weapon.front;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class ZicaLaser extends Weapon {

    private static final int FRAME = 102;
    private final float speed;

    public ZicaLaser(RessourcesHandler rh) {
        super(rh, "Zica Laser", 20, 1200);
        this.speed = 6.0f;
    }

    private void laser(Ship ship, int dmg, int of, int ox) {
        this.addBullet(ship, this.l, dmg, FRAME + of, 0.0f, this.speed, ox, -24);
        this.addBullet(ship, this.l, dmg, FRAME + 15 + of, 0.0f, this.speed, ox, -12);
        this.addBullet(ship, this.l, dmg, FRAME + 30 + of, 0.0f, this.speed, ox, 0);
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 20;
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                this.setRate(350);
                this.setEnergy(70);
                this.laser(ship, dmg, 0, 0);
                break;
            case 2:
                this.setRate(300);
                this.setEnergy(75);
                this.laser(ship, dmg, 0, 0);
                break;
            case 3:
                this.setRate(300);
                this.setEnergy(80);
                this.laser(ship, dmg, 0, -6);
                this.laser(ship, dmg, 0, 6);
                break;
            case 4:
                this.setRate(250);
                this.setEnergy(90);
                this.laser(ship, dmg, 0, -6);
                this.laser(ship, dmg, 0, 6);
                break;
            case 5:
                this.setRate(250);
                this.setEnergy(100);
                this.laser(ship, dmg + 30, 1, 0);
                break;
            case 6:
                this.setRate(200);
                this.setEnergy(120);
                this.laser(ship, dmg + 30, 1, -6);
                this.laser(ship, dmg + 30, 1, 6);
                break;
        }
        SoundManager.play(SoundManager.SFX.WEAPON_ZICALASER);
    }
}
