package com.b3dgs.tyrian.weapon.rear;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class HeavyMissilesRear extends Weapon {

    private static final int FRAME = 121;
    private final float speed;
    private boolean altern;

    public HeavyMissilesRear(RessourcesHandler rh) {
        super(rh, "Rear Heavy Missiles", 11, 1100);
        this.speed = 1.0f;
        this.altern = false;
        this.front = false;
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 70;
        this.setRate(400);
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                this.setEnergy(125);
                this.altern = !this.altern;
                if (this.altern) {
                    this.addBullet(ship, this.h, dmg, FRAME + 15, -this.speed * 0.6f, this.speed * 0.6f, -2, -8);
                } else {
                    this.addBullet(ship, this.h, dmg, FRAME + 30, this.speed * 0.6f, this.speed * 0.6f, 2, -8);
                }
                break;
            case 2:
                this.setEnergy(170);
                this.addBullet(ship, this.h, dmg + 10, FRAME + 16, -this.speed * 0.6f, this.speed * 0.6f, -2, -8);
                this.addBullet(ship, this.h, dmg + 10, FRAME + 31, this.speed * 0.6f, this.speed * 0.6f, -2, -8);
                break;
            case 3:
                this.setEnergy(190);
                this.addBullet(ship, this.h, dmg, FRAME + 15, -this.speed * 0.6f, this.speed * 0.6f, -2, -8);
                this.addBullet(ship, this.h, 30L, dmg, FRAME + 15, -this.speed * 0.6f, this.speed * 0.6f, -2, 0);
                this.addBullet(ship, this.h, dmg, FRAME + 30, this.speed * 0.6f, this.speed * 0.6f, 2, -8);
                this.addBullet(ship, this.h, 30L, dmg, FRAME + 30, this.speed * 0.6f, this.speed * 0.6f, 2, 0);
                break;
            case 4:
                this.setEnergy(220);
                this.addBullet(ship, this.h, dmg + 10, FRAME + 16, -this.speed * 0.6f, this.speed * 0.6f, -2, -8);
                this.addBullet(ship, this.h, 30L, dmg + 10, FRAME + 16, -this.speed * 0.6f, this.speed * 0.6f, -2, 0);
                this.addBullet(ship, this.h, dmg + 10, FRAME + 31, this.speed * 0.6f, this.speed * 0.6f, 2, -8);
                this.addBullet(ship, this.h, 30L, dmg + 10, FRAME + 31, this.speed * 0.6f, this.speed * 0.6f, 2, 0);
                break;
            case 5:
                this.setEnergy(260);
                this.addBullet(ship, this.h, dmg + 20, FRAME + 17, -this.speed * 0.6f, this.speed * 0.6f, -2, -8);
                this.addBullet(ship, this.h, 30L, dmg + 20, FRAME + 17, -this.speed * 0.6f, this.speed * 0.6f, -2, 0);
                this.addBullet(ship, this.h, dmg + 20, FRAME + 32, this.speed * 0.6f, this.speed * 0.6f, 2, -8);
                this.addBullet(ship, this.h, 30L, dmg + 20, FRAME + 32, this.speed * 0.6f, this.speed * 0.6f, 2, 0);
                break;
            case 6:
                this.setEnergy(290);
                this.addBullet(ship, this.h, 60L, dmg, FRAME + 15, -this.speed * 0.6f, this.speed * 0.6f, -2, 16);
                this.addBullet(ship, this.h, 30L, dmg + 10, FRAME + 16, -this.speed * 0.6f, this.speed * 0.6f, -2, 8);
                this.addBullet(ship, this.h, dmg + 20, FRAME + 17, -this.speed * 0.6f, this.speed * 0.6f, -2, 0);
                this.addBullet(ship, this.h, 60L, dmg + 20, FRAME + 30, this.speed * 0.6f, this.speed * 0.6f, 2, 16);
                this.addBullet(ship, this.h, 30L, dmg + 10, FRAME + 31, this.speed * 0.6f, this.speed * 0.6f, 2, 8);
                this.addBullet(ship, this.h, dmg, FRAME + 32, this.speed * 0.6f, this.speed * 0.6f, 2, 0);
                break;

        }
        SoundManager.play(SoundManager.SFX.WEAPON_MISSILE);
    }
}