package com.b3dgs.tyrian.weapon.rear;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class RearCannon extends Weapon {

    private static final int FRAME = 15;
    private final float speed;

    public RearCannon(RessourcesHandler rh) {
        super(rh, "Rear Cannon", 5, 750);
        this.speed = 4.0f;
        this.front = false;
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 20;
        this.setRate(250);
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                this.setEnergy(120);
                this.addBullet(ship, this.l, dmg, FRAME, 0.0f, -this.speed, 0, 6);
                this.addBullet(ship, this.l, dmg, FRAME + 15, -this.speed, 0.0f, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 30, this.speed, 0.0f, 6, 0);
                break;
            case 2:
                this.setEnergy(130);
                this.addBullet(ship, this.l, dmg, FRAME + 16, -this.speed, 0.0f, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 31, this.speed, 0.0f, 6, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, -this.speed, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, -this.speed, 6, 0);
                break;
            case 3:
                this.setEnergy(140);
                this.addBullet(ship, this.l, dmg, FRAME + 17, -this.speed, 0.0f, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 32, this.speed, 0.0f, 6, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 62, -this.speed / 2, -this.speed / 2, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 63, this.speed / 2, -this.speed / 2, 6, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, -this.speed, 3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, -this.speed, -3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, -this.speed, -3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, -this.speed, 3, 0);
                break;
            case 4:
                this.setEnergy(150);
                this.addBullet(ship, this.l, dmg, FRAME + 45 + 30, -this.speed, this.speed / 4, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 46 + 30, this.speed, this.speed / 4, 6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 60 + 30, -this.speed, -this.speed / 4, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 61 + 30, this.speed, -this.speed / 4, 6, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 62, -this.speed / 2, -this.speed / 2, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 63, this.speed / 2, -this.speed / 2, 6, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, -this.speed, 3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, -this.speed, -3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, -this.speed, -3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, -this.speed, 3, 0);
                break;
            case 5:
                this.setEnergy(160);
                this.addBullet(ship, this.l, dmg, FRAME + 45 + 30, -this.speed, this.speed / 4, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 46 + 30, this.speed, this.speed / 4, 6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 60 + 30, -this.speed, -this.speed / 4, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 61 + 30, this.speed, -this.speed / 4, 6, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 62 + 30, -this.speed / 2, -this.speed / 2, -6, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 63 + 30, this.speed / 2, -this.speed / 2, 6, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, -this.speed, 3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 64, -this.speed / 4, -this.speed, -3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, -this.speed, -3, 0);
                this.addBullet(ship, this.l, dmg, FRAME + 65, this.speed / 4, -this.speed, 3, 0);

                this.addBullet(ship, this.l, dmg, FRAME + 2, 0.0f, -this.speed, 0, 6);
                break;
            case 6:
                this.setEnergy(180);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 51, -this.speed / 2, this.speed / 2, 0, 0);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 52, this.speed / 2, this.speed / 2, 0, 0);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 51 + 15, -this.speed / 2, -this.speed / 2, 0, 0);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 52 + 15, this.speed / 2, -this.speed / 2, 0, 0);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 51 + 30, -this.speed, 0.0f, 0, 0);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 53 + 30, this.speed, 0.0f, 0, 0);
                this.addBullet(ship, this.l, dmg + 20, FRAME + 51 + 17, 0.0f, -this.speed, 0, 0);
                break;
        }
        SoundManager.play(SoundManager.SFX.WEAPON_PULSE);
    }
}
