package com.b3dgs.tyrian.weapon.rear;

import com.b3dgs.tyrian.RessourcesHandler;
import com.b3dgs.tyrian.SoundManager;
import com.b3dgs.tyrian.gameplay.Ship;
import com.b3dgs.tyrian.weapon.Weapon;

public class VulcanCannonRear extends Weapon {

    private static final int FRAME = 94;
    private final float speed;
    private int offsetX;
    private int offsetMargin, offsetSpeed;

    public VulcanCannonRear(RessourcesHandler rh) {
        super(rh, "Rear Vulcan Cannon", 8, 800);
        this.speed = 6.0f;
        this.front = false;
    }

    private void vulcan(Ship ship, int dmg, int of) {
        this.addBullet(ship, this.l, dmg, FRAME + of, -this.speed / 2, this.speed, -(float) Math.sin(Math.toRadians(this.offsetX)) * this.offsetMargin / 2, 4);
        this.addBullet(ship, this.l, dmg, FRAME + 1 + of, this.speed / 2, this.speed, (float) Math.sin(Math.toRadians(this.offsetX)) * this.offsetMargin / 2, 4);
    }

    @Override
    protected void fire(Ship ship) {
        int dmg = 12;
        this.setEnergy(100);
        this.setCollision(0, 1, 0, 0.5f);
        switch (this.level.getCurrent()) {
            case 1:
                this.setRate(150);
                this.offsetSpeed = 90;
                this.offsetMargin = 4;
                this.vulcan(ship, dmg, 0);
                break;
            case 2:
                this.setRate(135);
                this.offsetSpeed = 80;
                this.offsetMargin = 5;
                this.vulcan(ship, dmg, 0);
                break;
            case 3:
                this.setRate(120);
                this.offsetSpeed = 70;
                this.offsetMargin = 6;
                this.vulcan(ship, dmg, 0);
                break;
            case 4:
                this.setRate(105);
                this.offsetSpeed = 60;
                this.offsetMargin = 7;
                this.vulcan(ship, dmg, 15);
                break;
            case 5:
                dmg += 12;
                this.setRate(90);
                this.offsetSpeed = 50;
                this.offsetMargin = 8;
                this.vulcan(ship, dmg, 15);
                break;
            case 6:
                dmg = 12;
                this.setRate(75);
                this.offsetSpeed = 40;
                this.offsetMargin = 9;
                this.vulcan(ship, dmg, 15);
                break;
        }
        this.offsetX += this.offsetSpeed;
        this.offsetX %= 360;
        SoundManager.play(SoundManager.SFX.WEAPON_VULCAN);
    }
}
